﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = CreateTable();
        }

        private DataTable CreateTable()
        {
            DataTable dt1 = new DataTable();
            dt1.Columns.Add("Exclude All");

            #region Commented out
            //dt1.Columns.Add("Col2", typeof(bool));
            //dt1.Columns.Add("Col3", typeof(bool));
            //dt1.Columns.Add("Col4", typeof(bool));
            //dt1.Columns.Add("Col5", typeof(bool));
            //dt1.Columns.Add("Col6", typeof(bool));
            //dt1.Columns.Add("Col7", typeof(bool));
            //dt1.Columns.Add("Col8", typeof(bool));
            //dt1.Columns.Add("Col9", typeof(bool));

            //dt1.Rows.Add(new object[] { "Text 1", false, true, false, true, false, true, false, false });
            //dt1.Rows.Add(new object[] { "Text 2", false, true, false, true, false, true, false, false });
            //dt1.Rows.Add(new object[] { "Text 3", false, true, false, true, false, true, false, false });
            //dt1.Rows.Add(new object[] { "Text 4", false, true, false, true, false, true, false, false });
            //dt1.Rows.Add(new object[] { "Text 5", false, true, false, true, false, true, false, false });
            //dt1.Rows.Add(new object[] { "Text 6", false, true, false, true, false, true, false, false });

            #endregion //Commented out

            dt1.Columns.Add("Col2");
            dt1.Columns.Add("Col3");
            dt1.Columns.Add("Col4");
            dt1.Columns.Add("Col5");
            dt1.Columns.Add("Col6");
            dt1.Columns.Add("Col7");
            dt1.Columns.Add("Col8");
            dt1.Columns.Add("Col9");

            dt1.Rows.Add(new object[] { "Text 1", false, true, false, true, false, true, false, false});
            dt1.Rows.Add(new object[] { "Text 2", false, true, false, true, false, true, false, false});
            dt1.Rows.Add(new object[] { "Text 3", false, true, false, true, false, true, false, false});
            dt1.Rows.Add(new object[] { "Text 4", false, true, false, true, false, true, false, false});
            dt1.Rows.Add(new object[] { "Text 5", false, true, false, true, false, true, false, false});
            dt1.Rows.Add(new object[] { "Text 6", false, true, false, true, false, true, false, false});

            return dt1;

        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.HeaderCheckBoxVisibility = Infragistics.Win.UltraWinGrid.HeaderCheckBoxVisibility.Always;
            e.Layout.Bands[0].Columns["Exclude All"].Header.Caption = string.Empty;
            //e.Layout.Override.HeaderCheckBoxSynchronization = Infragistics.Win.UltraWinGrid.HeaderCheckBoxSynchronization.None;            
        }

        private void ultraGrid1_AfterHeaderCheckStateChanged(object sender, Infragistics.Win.UltraWinGrid.AfterHeaderCheckStateChangedEventArgs e)
        {
            UltraGridColumn column = e.Column;
            if (column.Header.Caption == string.Empty)
            {
                CheckState newCheckState = column.GetHeaderCheckedState(e.Rows);
                switch (newCheckState)
                {
                    case CheckState.Checked:
                    case CheckState.Unchecked:
                        ColumnsCollection columns = column.Band.Columns;
                        foreach (UltraGridColumn siblingColumn in columns)
                        {
                            if (siblingColumn == column)
                                continue;
                            siblingColumn.SetHeaderCheckedState(e.Rows, (newCheckState == CheckState.Checked));
                        }
                        break;
                    default:
                        break;
                }
            }
        }
    }
}
